SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'SebastianGarbi 4/29/2013 19:28'!
blueGhost

	^(BlueGhost new).! !

!PacManTest methodsFor: 'actors' stamp: 'SebastianGarbi 4/29/2013 19:50'!
blueberry

	^(Blueberry new).! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
down

	^(0@ -1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 20:12'!
ghostHouseDoorType

	^(GhostHouseDoorType new)! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
left

	^(-1@0).! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 20:31'!
leftTransporterType

	^LeftTransporterType new.! !

!PacManTest methodsFor: 'actors' stamp: 'SebastianGarbi 4/29/2013 19:37'!
pacman

	^(PacMan new).! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
right

	^(1@0). ! !

!PacManTest methodsFor: 'construction block types' stamp: 'ebastian 5/4/2013 16:42'!
spaceType

	^(SpaceType new). 
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'SebastianGarbi 4/29/2013 20:05'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
up

	^(0@1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 19:31'!
wallType

	^(WallType new).! !

Object subclass: #BloqueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BloqueType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 16:51'!
nextPositionFor: aPersonajeQueSeMueve going: aDirection
	^aPersonajeQueSeMueve nextPositionMovingInto: self going: aDirection.! !

!BloqueType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:10'!
nextPositionForBlueberry: aBlueberry going: aPoint 
	self shouldBeImplemented.! !

!BloqueType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:15'!
nextPositionForGhost: aBlueGhost going: aPoint 
	self shouldBeImplemented.! !

!BloqueType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:15'!
nextPositionForPacman: aPacMan going: aPoint 
	self shouldBeImplemented.! !

BloqueType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 16:21'!
nextPositionForBlueberry: aBlueberry going: aPoint 
	^aBlueberry position + aPoint.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 16:04'!
nextPositionForGhost: aBlueGhost going: aPoint 
	^aBlueGhost position + aPoint.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 16:16'!
nextPositionForPacman: aPacMan going: aPoint 
	^aPacMan position.! !

BloqueType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 18:42'!
nextPositionForBlueberry: aBlueberry going: aPoint 
	^(5@10).! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 18:42'!
nextPositionForGhost: aBlueGhost going: aPoint 
	^aBlueGhost position! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 18:42'!
nextPositionForPacman: aPacMan going: aPoint 
	^(3@10).! !

BloqueType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 16:36'!
nextPositionFor: aPersonajeQueSeMueve going: aDirection  
	^(aPersonajeQueSeMueve position + aDirection).! !

BloqueType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 15:33'!
nextPositionFor: aPersonajeQueSeMueve going: aDirection 
	^aPersonajeQueSeMueve position .! !

Object subclass: #PersonajeQueSeMueve
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PersonajeQueSeMueve subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:07'!
nextPositionMovingInto: aBloqueType going: aDirection 
	^aBloqueType nextPositionForGhost: self going: aDirection.! !

PersonajeQueSeMueve subclass: #Blueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Blueberry methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:06'!
nextPositionMovingInto: aBloqueType going: aDirection 
	^aBloqueType nextPositionForBlueberry: self going: aDirection.! !

PersonajeQueSeMueve subclass: #PacMan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacMan methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:07'!
nextPositionMovingInto: aBloqueType going: aDirection 
	^aBloqueType nextPositionForPacman: self going: aDirection.! !

!PersonajeQueSeMueve methodsFor: 'as yet unclassified' stamp: 'ebastian 5/4/2013 17:06'!
nextPositionMovingInto: aBloqueType going: aDirection 
	self shouldBeImplemented.! !

!PersonajeQueSeMueve methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 19:42'!
position
	^(0@0).! !
